From 52d7cb61cd14b1d4ea9fe84a93127c1156243cd6 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Sep 28 2017 17:30:56 +0000
Subject: [PATCH 946/1001] Add tests for d8ed17d


---

diff --git a/hubs/tests/test_authn.py b/hubs/tests/test_authn.py
new file mode 100644
index 0000000..350edf3
--- /dev/null
+++ b/hubs/tests/test_authn.py
@@ -0,0 +1,52 @@
+from __future__ import absolute_import, unicode_literals
+
+import flask
+
+import hubs.app
+from hubs.tests import APPTest, FakeAuthorization
+
+
+class AuthnTestCase(APPTest):
+
+    def setUp(self):
+        super(AuthnTestCase, self).setUp()
+        self.app_context = hubs.app.app.app_context()
+        self.app_context.__enter__()
+        self.req_context = hubs.app.app.test_request_context()
+        self.req_context.__enter__()
+        flask.g.db = self.session
+
+    def tearDown(self):
+        self.req_context.__exit__(None, None, None)
+        self.app_context.__exit__(None, None, None)
+        super(AuthnTestCase, self).tearDown()
+
+    def test_expired_auth(self):
+        # Previous user is still in the session
+ 
+        flask.session["auth"] = dict(
+            nickname="olduser",
+            name="olduser",
+            fullname="olduser",
+            email="olduser@example.com",
+            zoneinfo="UTC",
+            sub="olduser",
+            cla="",
+            groups=[],
+            logged_in=True,
+            )
+        # Now the new user logs in
+        flask.g.oidc_id_token = dict(
+            nickname="newuser",
+            name="newuser",
+            fullname="newuser",
+            email="newuser@example.com",
+            zoneinfo="UTC",
+            sub="newuser",
+            cla="",
+            groups=[],
+            )
+        # And the hook is called
+        hubs.app.check_auth()
+        self.assertEqual(flask.g.auth.nickname, "newuser")
+        self.assertEqual(flask.session["auth"]["nickname"], "newuser")

